#!/bin/bash
#
# gen-perf-script.sh
# Bltsville performance tests: test script generator
#
# This script creates the actual performance test script.
# Due to the limited number of shell command available on Android,
# we don't execute the tests directly.  Instead we generate the test
# command here, and pipe them out to another sript file, which only uses
# very basic shell commands.  This generated test script can then be
# executed on either Linux or Android to run the tests.
#
# Usage:
# gen-perf-script.sh <scriptname> <path to bvtest>
#
# We assume that everything we need to run the script (bvtest executable, input
# images, and reference images) are all located in this directory.
#
# We will measure the performance of the following operations:
#
# -a. RGBA24 to RGBA24
# -b. RGBx24 to RGB16
# -c. RGBx24 to RGB16 with dithering
# -d. RGBA24 to RGBA24 with non-interpolated scaling
# -e. RGBA24 src1over RGBx24 to RGBx24 (src2 == dest)
# -f. RGBA24 src1over RGBA24 to RGBA24 (src2 == dest)
# -g. RGBA24 src1over RGBA24 to RGBA24 with non-interpolated scaling (src2 == dest)
# -h. RGBA24 src1over RGB16 to RGB16 (src2 == dest)
# -i. RGBA24 src1over RGB16 to RGB16 with dither (src2 == dest)
# -j. RGBA24 src1over RGB16 to RGB16 with non-interpolated scaling (src2 == dest)
# -k. RGBA24 src1over RGB16 to RGB16 with non-interpolated scaling and dither (src2 == dest)
# -l. RGB16 to RGB124
# -m. NV12 to RGBx24
# -n. YUYV to RGBx24
#
# We do not bother writing the output file. Perhaps we shouldn't bother reading
# the input files either...
#
version=2.0.03
lib=$1
scriptname=$2
bvtpath=$3
resultsname=perfresults.csv

# Full size
src_w=2048
src_h=1536
stride32=8192
stride24=6144
stride16=4096

# half size
half_w=1024
half_h=768

# 75 percent
tq_w=1536
tq_h=1152


# Size of source image
src_dim=${src_w}x${src_h}
src_rc=0,0-${src_dim}

# Size of the destination image without scaling
dst_dim=${src_dim}
dst_rc=${src_rc}

# Scaled down to 75 of normal size
tq_dim=${tq_w}x${tq_h}
tq_rc=0,0-${tq_dim}

# Upper left corner of source.
half_dim=${half_w}x${half_h}
ul_rc=0,0-${half_dim}



##############################################################################
# Clear all the params out for a new operation.
# After calling this, just set what you need and then call Blit()
#
function Clear-Parms() {
  blt_tag=
  src1_cmd=
  src2_cmd=
  mask_cmd=
  rot_cmd=
  dither_cmd=
  scale_cmd=
  clip_cmd=
  clip_tag=
  rop_cmd=
  blend_cmd=
  dst_cmd=
  dst_file_name=
  dst_file_cmd=
  loop_times=1
}


##############################################################################
# Generate a blit command from all the parameters.
#
function Blit() {

  # Don't generate output files.
  # dst_file_name="${blt_tag}-${clip_tag}"
  # dst_file_cmd="-dstfile ${dst_file_name}.tga"
  dst_file_name=
  dst_file_cmd=

  echo "${bvtpath}bvtest -premap ${src1_cmd} ${src2_cmd} ${mask_cmd} ${blend_cmd} ${clip_cmd} ${rot_cmd} ${dst_cmd} ${dst_file_cmd} ${dither_cmd} ${scale_cmd} ${rop_cmd} -imp $lib -preseed -pretouch 4096 -loops ${loop_times} -profile -profout ${resultsname}" >> $scriptname
  echo "echo >> ${resultsname} " >> $scriptname

}


echo Creating input images
##############################################################################
#
# Start with an empty script
#
echo "# This script automatically generated by 'gen-perf-script.sh'" > $scriptname
echo "echo > ${resultsname}" >> $scriptname
echo "echo Bltsville QuickPerf $version" >> $scriptname
echo "${bvtpath}bvtest -version" >> $scriptname

##############################################################################
#
# Generate RGBA24 source image
#
echo "${bvtpath}bvtest -src1file Fruit-2048x1536.jpg -src1 RGB124 2048x1536 -src1rect 0,0-2048x1536 -dst RGB124 ${src_dim} -dstrect ${src_rc} -dstfile test-pattern.raw -rop CCCC"  >> $scriptname
RGBA24_file_name="test-pattern-RGBA24-${src_dim}\(${stride32}\).raw"
echo "mv test-pattern-RGBx24-${src_dim}\(${stride32}\).raw  ${RGBA24_file_name}"  >> $scriptname

##############################################################################
#
# Generate RGBx24 source image
#
echo "${bvtpath}bvtest -src1file Fruit-2048x1536.jpg -src1 RGB124 2048x1536 -src1rect 0,0-2048x1536 -dst RGB124 ${src_dim} -dstrect ${src_rc} -dstfile test-pattern.raw -rop CCCC"  >> $scriptname
RGBx24_file_name="test-pattern-RGBx24-${src_dim}\(${stride32}\).raw"

##############################################################################
#
# Generate RGB24 source image
#
echo "${bvtpath}bvtest -src1file ${RGBx24_file_name} -src1rect ${src_rc} -dst RGB24 ${src_dim} -dstrect ${src_rc} -dstfile test-pattern.raw -rop CCCC"  >> $scriptname
RGB24_file_name="test-pattern-RGB24-${src_dim}\(${stride24}\).raw"

##############################################################################
#
# Generate RGB16 source image
#
echo "${bvtpath}bvtest -src1file ${RGB24_file_name} -src1rect ${src_rc} -dst RGB16 ${src_dim} -dstrect ${src_rc} -dstfile test-pattern.raw -rop CCCC"  >> $scriptname
RGB16_file_name="test-pattern-RGB16-${src_dim}\(${stride16}\).raw"


##############################################################################
#
# Generate the RGBA24 overlay image
#
echo "${bvtpath}bvtest -src1file kings_1_bg_051802.jpg -src1 RGB124 800x600 -src1rect 0,0-800x600 -dst RGB124 ${src_dim} -dstrect ${src_rc} -dstfile overlay-pattern.raw -rop CCCC"  >> $scriptname
RGBA24_overlay_file_name="overlay-pattern-RGBA24-${src_dim}\(${stride32}\).raw"
echo "mv overlay-pattern-RGBx24-${src_dim}\(${stride32}\).raw  ${RGBA24_overlay_file_name}"  >> $scriptname

##############################################################################
#
# Generate the RGBx24 overlay image
#
echo "${bvtpath}bvtest -src1file kings_1_bg_051802.jpg -src1 RGB124 800x600 -src1rect 0,0-800x600 -dst RGB124 ${src_dim} -dstrect ${src_rc} -dstfile overlay-pattern.raw -rop CCCC"  >> $scriptname
RGBx24_overlay_file_name="overlay-pattern-RGBx24-${src_dim}\(${stride32}\).raw"



##############################################################################
# -a. RGBA24 to RGBA24
#
echo Creating test 'RGBA24 to RGBA24'
echo "echo Measuring test 'RGBA24 to RGBA24'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGBA24 to RGBA24,\ " >> $scriptname
blt_tag=copy-RGBA24-to-RGBA24
rop_cmd="-rop CCCC"
src1_cmd="-src1file ${RGBA24_file_name} -src1rect ${src_rc}"
dst_cmd="-dst RGBA24 ${dst_dim} -dstrect ${dst_rc}"
loop_times=500
Blit

##############################################################################
# -b. RGBx24 to RGB16
#
echo Creating test 'RGBx24 to RGB16'
echo "echo Measuring test 'RGBx24 to RGB16'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGBx24 to RGB16,\ " >> $scriptname
blt_tag=copy-RGBx24-to-RGB16
rop_cmd="-rop CCCC"
src1_cmd="-src1file ${RGBx24_file_name} -src1rect ${src_rc}"
dst_cmd="-dst RGB16 ${dst_dim} -dstrect ${dst_rc}"
loop_times=500
Blit

##############################################################################
# -c. RGBx24 to RGB16 with dithering
#
echo Creating test 'RGBx24 to RGB16 with dither'
echo "echo Measuring test 'RGBx24 to RGB16 with dithering'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGBx24 to RGB16 with dithering,\ " >> $scriptname
blt_tag=dither-RGBx24-to-RGB16
rop_cmd="-rop CCCC"
src1_cmd="-src1file ${RGBx24_file_name} -src1rect ${src_rc}"
dst_cmd="-dst RGB16 ${dst_dim} -dstrect ${dst_rc}"
dither_cmd="-dither best_on"
loop_times=500
Blit


##############################################################################
# -d. RGBA24 to RGBA24 with non-interpolated scaling
#
echo Creating test 'RGBA24 to RGBA24 with scale'
Clear-Parms
rop_cmd="-rop CCCC"
scale_cmd="-scale fastest"
loop_times=500

# scale up
echo "echo Measuring test 'RGBA24 to RGBA24 with non-interpolated scaling 1'." >> $scriptname
echo "echo -n >> ${resultsname} RGBA24 to RGBA24 with non-interpolated scale up,\ " >> $scriptname
blt_tag=scale-up-RGBA24-to-RGBA24
src1_cmd="-src1file ${RGBA24_file_name} -src1rect ${ul_rc}"
dst_cmd="-dst RGBA24 ${dst_dim} -dstrect ${dst_rc}"
Blit

# scale down to 75%
echo "echo Measuring test 'RGBA24 to RGBA24 with non-interpolated scaling 2'." >> $scriptname
echo "echo -n >> ${resultsname} RGBA24 to RGBA24 with non-interpolated 3/4 scale ,\ " >> $scriptname
blt_tag=scale-down-75-RGBA24-to-RGBA24
src1_cmd="-src1file ${RGBA24_file_name} -src1rect ${src_rc}"
dst_cmd="-dst RGBA24 ${tq_dim} -dstrect ${tq_rc}"
Blit

#scale down half
echo "echo Measuring test 'RGBA24 to RGBA24 with non-interpolated scaling 3'." >> $scriptname
echo "echo -n >> ${resultsname} RGBA24 to RGBA24 with non-interpolated half scale,\ " >> $scriptname
blt_tag=scale-down-half-RGBA24-to-RGBA24
src1_cmd="-src1file ${RGBA24_file_name} -src1rect ${src_rc}"
dst_cmd="-dst RGBA24 ${half_dim} -dstrect ${ul_rc}"
Blit


##############################################################################
# -e. RGBA24 src1over RGBx24 to RGBx24 (src2 == dest)
#
echo Creating test 'RGBA24 src1over RGBx24 to RGBx24 with global alpha'
echo "echo Measuring test 'RGBA24 src1over RGBx24 to RGBx24 with global alpha'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGBA24 src1over RGBx24 to RGBx24 with global alpha,\ " >> $scriptname
blt_tag=blend-RGBA24-src1over+global-RGBx24
blend_cmd="-blend src1over+global -alpha 80"
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${src_rc}"
src2_cmd="-src2file ${RGBx24_file_name} -src2rect ${src_rc}"
dst_cmd="-dst RGBx24 src2 -dstrect ${src_rc}"
loop_times=500
Blit

echo Creating test 'RGBA24 src1over RGBx24 to RGBx24 with local alpha'
echo "echo Measuring test 'RGBA24 src1over RGBx24 to RGBx24 with local alpha'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGBA24 src1over RGBx24 to RGBx24 with local alpha,\ " >> $scriptname
blt_tag=blend-RGBA24-src1over-RGBx24
blend_cmd="-blend src1over"
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${src_rc}"
src2_cmd="-src2file ${RGBx24_file_name} -src2rect ${src_rc}"
dst_cmd="-dst RGBx24 src2 -dstrect ${src_rc}"
loop_times=500
Blit


##############################################################################
# -f. RGBA24 src1over RGBA24 to RGBA24 (src2 == dest)
#
echo Creating test 'RGBA24 src1over RGBA24 to RGBA24 with global alpha'
echo "echo Measuring test 'RGBA24 src1over RGBA24 to RGBA24 with global alpha'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGBA24 src1over RGBA24 to RGBA24 with global alpha,\ " >> $scriptname
blt_tag=blend-RGBA24-src1over+global-RGBA24
blend_cmd="-blend src1over+global -alpha 80"
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${src_rc}"
src2_cmd="-src2file ${RGBA24_file_name} -src2rect ${src_rc}"
dst_cmd="-dst RGBA24 src2 -dstrect ${src_rc}"
loop_times=500
Blit

echo Creating test 'RGBA24 src1over RGBA24 to RGBA24 with local alpha'
echo "echo Measuring test 'RGBA24 src1over RGBA24 to RGBA24 with local alpha'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGBA24 src1over RGBA24 to RGBA24 with local alpha,\ " >> $scriptname
blt_tag=blend-RGBA24-src1over-RGBA24
blend_cmd="-blend src1over"
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${src_rc}"
src2_cmd="-src2file ${RGBA24_file_name} -src2rect ${src_rc}"
dst_cmd="-dst RGBA24 src2 -dstrect ${src_rc}"
loop_times=500
Blit


##############################################################################
# -g. RGBA24 src1over RGBA24 to RGBA24 with non-interpolated scaling (src2 == dest)
#
echo Creating test 'RGBA24 src1over RGBA24 to RGBA24 with scale'
echo "echo Measuring test 'RGBA24 src1over RGBA24 to RGBA24 with non-interpolated scaling'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGBA24 src1over RGBA24 to RGBA24 with non-interpolated scaling,\ " >> $scriptname
blt_tag=blend-scale-RGBA24-src1over-RGBA24
blend_cmd="-blend src1over"
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${ul_rc}"
src2_cmd="-src2file ${RGBA24_file_name} -src2rect ${src_rc}"
dst_cmd="-dst RGBA24 src2 -dstrect ${dst_rc}"
scale_cmd="-scale fastest"
loop_times=500
Blit


##############################################################################
# -h. RGBA24 src1over RGB16 to RGB16 (src2 == dest)
#
echo Creating test 'RGBA24 src1over RGB16 to RGB16 with global alpha'
echo "echo Measuring test 'RGBA24 src1over RGB16 to RGB16 with global alpha'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGBA24 src1over RGB16 to RGB16 with global alpha,\ " >> $scriptname
blt_tag=blend-RGBA24-src1over+global-RGB16
blend_cmd="-blend src1over+global -alpha 80"
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${src_rc}"
src2_cmd="-src2file ${RGB16_file_name} -src2rect ${src_rc}"
dst_cmd="-dst RGB16 src2 -dstrect ${dst_rc}"
loop_times=500
Blit

echo Creating test 'RGBA24 src1over RGB16 to RGB16 with local alpha'
echo "echo Measuring test 'RGBA24 src1over RGB16 to RGB16 with local alpha'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGBA24 src1over RGB16 to RGB16 with local alpha,\ " >> $scriptname
blt_tag=blend-RGBA24-src1over-RGB16
blend_cmd="-blend src1over"
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${src_rc}"
src2_cmd="-src2file ${RGB16_file_name} -src2rect ${src_rc}"
dst_cmd="-dst RGB16 src2 -dstrect ${dst_rc}"
loop_times=500
Blit


##############################################################################
# -i. RGBA24 src1over RGB16 to RGB16 with dither (src2 == dest)
#
echo Creating test 'RGBA24 src1over RGB16 to RGB16 with dither with global alpha'
echo "echo Measuring test 'RGBA24 src1over RGB16 to RGB16 with dither with global alpha'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGBA24 src1over RGB16 to RGB16 with dither with global alpha,\ " >> $scriptname
blt_tag=dither-blend-RGBA24-src1over+global-RGB16
blend_cmd="-blend src1over+global -alpha 80"
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${src_rc}"
src2_cmd="-src2file ${RGB16_file_name} -src2rect ${src_rc}"
dst_cmd="-dst RGB16 src2 -dstrect ${dst_rc}"
dither_cmd="-dither best_on"
loop_times=500
Blit

echo Creating test 'RGBA24 src1over RGB16 to RGB16 with local alpha'
echo "echo Measuring test 'RGBA24 src1over RGB16 to RGB16 with dither with local alpha'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGBA24 src1over RGB16 to RGB16 with dither with local alpha,\ " >> $scriptname
blt_tag=dither-blend-RGBA24-src1over-RGB16
blend_cmd="-blend src1over"
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${src_rc}"
src2_cmd="-src2file ${RGB16_file_name} -src2rect ${src_rc}"
dst_cmd="-dst RGB16 src2 -dstrect ${dst_rc}"
dither_cmd="-dither best_on"
loop_times=500
Blit

##############################################################################
# -j. RGBA24 src1over RGB16 to RGB16 with non-interpolated scaling (src2 == dest)
#
echo Creating test 'RGBA24 src1over RGB16 to RGB16 with scale'
Clear-Parms
blend_cmd="-blend src1over"
loop_times=500

# scale up
echo "echo Measuring test 'RGBA24 src1over RGB16 to RGB16 with non-interpolated scaling 1'." >> $scriptname
echo "echo -n >> ${resultsname} RGBA24 src1over RGB16 to RGB16 with non-interpolated scale up,\ " >> $scriptname
blt_tag=scale-up-blend-RGBA24-src1over-RGB16
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${ul_rc}"
src2_cmd="-src2file ${RGB16_file_name} -src2rect ${src_rc}"
dst_cmd="-dst RGB16 src2 -dstrect ${dst_rc}"
Blit

# scale 75 %
echo "echo Measuring test 'RGBA24 src1over RGB16 to RGB16 with non-interpolated scaling 2'." >> $scriptname
echo "echo -n >> ${resultsname} RGBA24 src1over RGB16 to RGB16 with non-interpolated scale down half,\ " >> $scriptname
blt_tag=scale-down-75-blend-RGBA24-src1over-RGB16
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${src_rc}"
src2_cmd="-src2file ${RGB16_file_name} -src2rect ${tq_rc}"
dst_cmd="-dst RGB16 src2 -dstrect ${tq_rc}"
Blit

# scale down half
echo "echo Measuring test 'RGBA24 src1over RGB16 to RGB16 with non-interpolated scaling 3'." >> $scriptname
echo "echo -n >> ${resultsname} RGBA24 src1over RGB16 to RGB16 with non-interpolated scale downb third,\ " >> $scriptname
blt_tag=scale-down-half-blend-RGBA24-src1over-RGB16
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${src_rc}"
src2_cmd="-src2file ${RGB16_file_name} -src2rect ${ul_rc}"
dst_cmd="-dst RGB16 src2 -dstrect ${ul_rc}"
Blit

##############################################################################
# -k. RGBA24 src1over RGB16 to RGB16 with non-interpolated scaling and dither (src2 == dest)
#
echo Creating test 'RGBA24 src1over RGB16 to RGB16 with scale and dither'
Clear-Parms
blend_cmd="-blend src1over"
dither_cmd="-dither best_on"
loop_times=500

# scale up
echo "echo Measuring test 'RGBA24 src1over RGB16 to RGB16 with scale and dither 1'." >> $scriptname
echo "echo -n >> ${resultsname} RGBA24 src1over RGB16 to RGB16 with non-interpolated scale up and dither,\ " >> $scriptname
blt_tag=dither-scale-up-blend-RGBA24-src1over-RGB16
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${ul_rc}"
src2_cmd="-src2file ${RGB16_file_name} -src2rect ${src_rc}"
dst_cmd="-dst RGB16 src2 -dstrect ${dst_rc}"
Blit

# scale down 75%
echo "echo Measuring test 'RGBA24 src1over RGB16 to RGB16 with scale and dither 2'." >> $scriptname
echo "echo -n >> ${resultsname} RGBA24 src1over RGB16 to RGB16 with non-interpolated scale down 3/4 and dither,\ " >> $scriptname
blt_tag=dither-scale-down-half-blend-RGBA24-src1over-RGB16
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${src_rc}"
src2_cmd="-src2file ${RGB16_file_name} -src2rect ${tq_rc}"
dst_cmd="-dst RGB16 src2 -dstrect ${tq_rc}"
Blit

# scale down half
echo "echo Measuring test 'RGBA24 src1over RGB16 to RGB16 with scale and dither 3'." >> $scriptname
echo "echo -n >> ${resultsname} RGBA24 src1over RGB16 to RGB16 with non-interpolated scale down half and dither,\ " >> $scriptname
blt_tag=dither-scale-down-third-blend-RGBA24-src1over-RGB16
src1_cmd="-src1file ${RGBA24_overlay_file_name} -src1rect ${src_rc}"
src2_cmd="-src2file ${RGB16_file_name} -src2rect ${ul_rc}"
dst_cmd="-dst RGB16 src2 -dstrect ${ul_rc}"
Blit

##############################################################################
# -l. RGB16 to RGB124
#
echo Creating test 'RGB16 to RGB124'
echo "echo Measuring test 'RGB16 to RGB124'." >> $scriptname
Clear-Parms
echo "echo -n >> ${resultsname} RGB16 to RGB124,\ " >> $scriptname
blt_tag=copy-RGB16-to-RGB124
rop_cmd="-rop CCCC"
src1_cmd="-src1file ${RGB16_file_name} -src1rect ${src_rc}"
dst_cmd="-dst RGB124 ${dst_dim} -dstrect ${dst_rc}"
loop_times=500
Blit


##############################################################################
# -m. NV12 to RGBx24
#
echo Creating test 'NV12 to RGBx24'
echo "echo Measuring test 'NV12 to RGBx24'." >> $scriptname
cp ../../../images/test-pattern-NV12-1920x1080\(1920\).raw .
YUV_file_name="test-pattern-NV12-1920x1080\(1920\).raw"
Clear-Parms
echo "echo -n >> ${resultsname} NV12 to RGBx24,\ " >> $scriptname
blt_tag=copy-NV12-to-RGBx24
rop_cmd="-rop CCCC"
src1_cmd="-src1file ${YUV_file_name} -src1rect 0,0-1920x1080"
dst_cmd="-dst RGBx24 1920x1080 -dstrect 0,0-1920x1080"
loop_times=500
Blit

##############################################################################
# -n. YUYV to RGBx24
#
echo Creating test 'YUYV to RGBx24'
echo "echo Measuring test 'YUYV to RGBx24'." >> $scriptname
cp ../../../images/test-pattern-YUYV-720x240\(1440\).raw .
YUV_file_name="test-pattern-YUYV-720x240\(1440\).raw"
Clear-Parms
echo "echo -n >> ${resultsname} YUYV to RGBx24,\ " >> $scriptname
blt_tag=copy-YUYV-to-RGBx24
rop_cmd="-rop CCCC"
src1_cmd="-src1file ${YUV_file_name} -src1rect 0,0-720x240"
dst_cmd="-dst RGBx24 720x240 -dstrect 0,0-720x240"
loop_times=500
Blit

# All done
 echo "echo " >> $scriptname
chmod 777 $scriptname

